org.cpsolver.exam.neighbours

## Class ExamSimpleNeighbour

- java.lang.Object
- - org.cpsolver.ifs.model.SimpleNeighbour<Exam,ExamPlacement>
  - - org.cpsolver.exam.neighbours.ExamSimpleNeighbour

- All Implemented Interfaces:
    Neighbour<Exam,ExamPlacement>

      public class ExamSimpleNeighbour
      extends SimpleNeighbour<Exam,ExamPlacement>

  Extension of `SimpleNeighbour`. The only difference is that the value ( `SimpleNeighbour.value(Assignment)`) is decreased by 1000 if the selected variable has no current assignment.
  Version:
    ExamTT 1.3 (Examination Timetabling)
    Copyright (C) 2008 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExamSimpleNeighbour(Assignment<Exam,ExamPlacement> assignment, ExamPlacement placement)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `assign(Assignment<Exam,ExamPlacement> assignment, long iteration)` Perform assignment
    `String` | `toString()`
    `protected static String` | `toString(double[] x)`
    `protected static String` | `toString(double[] x, double[] y)`
    `double` | `value(Assignment<Exam,ExamPlacement> assignment)` Improvement in the solution value if this neighbour is accepted.

    - ### Methods inherited from class org.cpsolver.ifs.model.SimpleNeighbour

      `assignments, getValue, getVariable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExamSimpleNeighbour

          public ExamSimpleNeighbour(Assignment<Exam,ExamPlacement> assignment,
                                     ExamPlacement placement)

  - ### Method Detail

    - #### assign

          public void assign(Assignment<Exam,ExamPlacement> assignment,
                             long iteration)

      Description copied from class: `SimpleNeighbour`
      Perform assignment
      Specified by:
        `assign` in interface `Neighbour<Exam,ExamPlacement>`
      Overrides:
        `assign` in class `SimpleNeighbour<Exam,ExamPlacement>`
      Parameters:
        `assignment` - current assignment
        `iteration` - current iteration

    - #### toString

          protected static String toString(double[] x)

    - #### toString

          protected static String toString(double[] x,
                                           double[] y)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `SimpleNeighbour<Exam,ExamPlacement>`

    - #### value

          public double value(Assignment<Exam,ExamPlacement> assignment)

      Description copied from class: `SimpleNeighbour`
      Improvement in the solution value if this neighbour is accepted.
      Specified by:
        `value` in interface `Neighbour<Exam,ExamPlacement>`
      Overrides:
        `value` in class `SimpleNeighbour<Exam,ExamPlacement>`
      Parameters:
        `assignment` - current assignment
      Returns:
        difference in the solution value when assigned